[一起来刷leetcode吧][5]--No.688 Knight Probability in Chessboard

这篇文章是程序自动发表的,详情可以见这里

这是leetcode的第688题--Knight Probability in Chessboard

  题目 On an NxN chessboard, a knight starts at the r-th row and c-th column and attempts to make exactly K moves. The rows and columns are 0 indexed, so the top-left square is (0, 0), and the bottom-right square is (N-1, N-1).

A chess knight has 8 possible moves it can make, as illustrated below. Each move is two squares in a cardinal direction, then one square in an orthogonal direction. [一起来刷leetcode吧][5]--No.688 Knight Probability in Chessboard

Each time the knight is to move, it chooses one of eight possible moves uniformly at random (even if the piece would go off the chessboard) and moves there.

The knight continues moving until it has made exactly K moves or has moved off the chessboard. Return the probability that the knight remains on the board after it has stopped moving. Example: * Input: 3, 2, 0, 0 * Output: 0.0625 * Explanation: There are two moves (to (1,2), (2,1)) that will keep the knight on the board. From each of those positions, there are also two moves that will keep the knight on the board. The total probability the knight stays on the board is 0.0625. Note: * N will be between 1 and 25. * K will be between 0 and 100. * The knight always initially starts on the board.

  思路 如果用递归写会超时,重复计算太多,用动态规划,状态由k,r,c确定,注意到第二十六行代码,最开始我加的dp[i-1][j][t],这样是错的,要加上由上一状态能到当前状态的,可以发现,当前状态能到上一状态的上一状态能到当前状态,   

show me the code

class Solution:
    def knightProbability(self, N, k, r, c):
        self.one=[(i,j) for i in (1,-1) for j in (2,-2)]
        self.one =[(j,i) for i in (1,-1) for j in (2,-2)]
        if k==0:return 1
        dp=[[[1]*N for i in range(N)] for j in range(k 1)]
        if N<4:
            for i,j in self.one:
                tr,tc = r i,j c 
                if 0<=tr<N and 0<=tc<N:break
            else:return 0
        for i in range(1,k 1):
            for j in range(N):
                for t in range(N):
                    sm =0
                    for g,h in self.one:
                        tr,tc = j g, t h
                        if 0<=tr<N and 0<=tc<N:
                            sm =dp[i-1][tr][tc]
                    dp[i][j][t] = sm/8
        #for i in dp:print(i)
        return dp[k][r][c]